Redmine - Feature #36699

Change the text of the user link when converting @user notation to html
2022-02-24 08:56 - Mizuki ISHIKAWA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Marius BALTEANU % Done: 0%
Category: Text formatting Estimated time: 0.00 hour

Target version:

Resolution: Fixed

Description

#13919 added the Mention feature to Redmine.
There are three types of notations that can be converted to user links: @user, user#1, and user:user. With this change, only @user
will have the Mention feature.

Currently, when you convert @jsmith to HTML, you get the link "John Smith".
| propose to change this to the following:

e Plan 1. john wilson Smith
¢ Plan 2. @jsmith(John Smith)
¢ Plan 3. @jsmith

Reason for change:
e The functions are different from those of other user#1 and user:user notations and should be separated.
¢ | think it's important to have @ in front of the name so that people who don't know much about Redmine realize that they can
use the Mention feature.
Concerns:
Since @jsmith has always been assumed to be converted to "John Smith", changing it may break the display of wiki pages and

issues.

Please let me know what you think.

Related issues:
Related to Redmine - Feature #13919: Mention user on issues and wiki pages us... Closed

Associated revisions

Revision 21440 - 2022-02-24 22:54 - Marius BALTEANU

Add class user-mention to user classes when user is linked using @ (#36699, #13919).

Revision 21468 - 2022-03-19 11:00 - Marius BALTEANU
Render mentioned users with leading @ and highlight (#36699, #13919).

History

#1 - 2022-02-24 22:33 - Marius BALTEANU

- Related to Feature #13919: Mention user on issues and wiki pages using @user with autocomplete added

#2 - 2022-02-24 23:02 - Marius BALTEANU

- File mention.png added

For now I've added the class user-mention to user links generated using @ (r21440).

The easiest way is to obtain "@John Smith" using two different approaches:

1. Only from CSS:

diff --git a/public/stylesheets/application.css b/public/stylesheets/application.css

index £837a710e..57b3a9680 100644
-—— a/public/stylesheets/application.css
+++ b/public/stylesheets/application.css
@@ -150,6 +150,9 @@ a img{ border: 0; }

a.issue.closed, a.issue.closed:link, a.issue.closed:visited { color: #999; text-decoration:

a.project.closed, a.project.closed:1link, a.project.closed:visited { color: #999; }
a.user.locked, a.user.locked:1link, a.user.locked:visited {color: #999;}
+a.user.user-mention:before {

+ content: "@";

+}

2. Rendered with @

diff --git a/app/helpers/application_helper.rb b/app/helpers/application_helper.rb
index 33f72el44..c91f7cbaa 100644
-—— a/app/helpers/application_helper.rb
+++ b/app/helpers/application_helper.rb
@@ -60,6 +60,7 @@ module ApplicationHelper
case principal
when User
name = h(principal.name (options|[:format]))
+ name = "@" + name if options[:is_mention]
css_classes = "'
if principal.active? || (User.current.admin? && principal.logged?)
url = user_url (principal, :only_path => only_path)
@@ -1265,7 +1266,7 @@ module ApplicationHelper
elsif sep == "@"

name = remove_double_qguotes (identifier)
u = User.visible.find by ("LOWER(login) = :s AND type = 'User'", :s => name.downcase)
= link = link_to_user(u, :only_path => only_path, :class => 'user-mention')
+ link = link_to_user(u, :only_path => only_path, :class => 'user-mention',
u
end

Also, maybe we should highlight the users linked with @:
mention.png

#3 - 2022-02-25 00:43 - Mizuki ISHIKAWA

Marius BALTEANU wrote:
For now I've added the class user-mention to user links generated using @ (r21440).
The easiest way is to obtain "@John Smith" using two different approaches:
1. Only from CSS:
(-]
2. Rendered with @
[-]
Also, maybe we should highlight the users linked with @:

mention.png

Thank you for your commit.

I think it's a good improvement that doesn't affect the existing look and feel, and people who want to change it can do so using css.

#4 - 2022-03-18 22:32 - Marius BALTEANU
- File 0001-Render-mentioned-users-with-leading-36699-13919.patch added

- Target version set to 5.0.0
| think it's better to actually render the display name with @. Patch attached.

#5 - 2022-03-19 11:01 - Marius BALTEANU
- Assignee set to Marius BALTEANU
- Target version deleted (5.0.0)

- Resolution set to Fixed
line-through;

:is_mention => true)
Change committed, thanks!

#6 - 2022-03-28 23:29 - Marius BALTEANU

- Status changed from New to Closed

Files
mention.png 48.5 KB 2022-02-24 Marius BALTEANU
0001-Render-mentioned-users-with-leading-36699-13919.patch 5.78 KB 2022-03-18 Marius BALTEANU
